#!/bin/bash
#
# $Id$
#
# FancyLibs
#
# Copyright (C) 2014 ITEG IT-Engineers GmbH
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

DELAYSECS="$1"

if [ -z "${DELAYSECS}" ] ; then
  echo "No delaySecs specfied, going to shutdown now."
fi

if [ "$UID" = "0" ] ; then
  SHUTDOWNCALL="/sbin/shutdown -h"
else
  SHUTDOWNCALL="/usr/bin/sudo /sbin/shutdown -h"
fi

if [ -n "$DELAYSECS" ] ; then
  SHUTDOWNCALL="$SHUTDOWNCALL -t $DELAYSECS"
fi

# don't use now on systemd installations, because this blocks
# us for 5 minutes when called from inside a daemon process.
if [ "$(readlink -f /sbin/shutdown)" != "/bin/systemctl" ] ; then
  SHUTDOWNCALL="$SHUTDOWNCALL now"
fi

MSG="Calling ${SHUTDOWNCALL}"
echo "$MSG"
logger -t fancybase -p user.notice -- fancybase-shutdown: ${MSG}

#SHUTDOWNCALL="/bin/false"
#MSG="OK, just calling ${SHUTDOWNCALL}"
#echo "$MSG"
#logger -t fancybase -p user.notice -- fancybase-shutdown: ${MSG}

${SHUTDOWNCALL} 
PRC=${PIPESTATUS[0]}

if [ "$PRC" = "0" ] ; then
  MSG="Sucessfully called ${SHUTDOWNCALL}"
  echo "$MSG"
  logger -t fancybase -p user.notice -- fancybase-shutdown: ${MSG}
  exit 0  
fi

MSG="ERROR: Bad returncode $PRC from ${SHUTDOWNCALL}"
echo "$MSG"
logger -t fancysock -p user.error -- fancybase-shutdown: ${MSG} Output follows.
exit $PRC
